package ascio.v2.examples;
import com.ascio.www._2007._01.*;
import com.ascio.www._2007._01.holders.*;
import ascio.lib.*;

public class Contact_UpdateExample {
	public static Response main() {
		AscioConfig config = new AscioConfig();
		V2 env = config.getTesting().getV2();


		Contact adminContact =  new Contact();
		adminContact.setFirstName("John");
		adminContact.setLastName("Doe");
		adminContact.setAddress1("Address1Test");
		adminContact.setPostalCode("888349");
		adminContact.setCity("CityTest");
		adminContact.setCountryCode("DK");
		adminContact.setEmail(config.getEmail());
		adminContact.setPhone("+45.123456789");


		Domain domain =  new Domain();
		domain.setDomainName(env.getProperties().getProperty("DomainName"));
		domain.setAdminContact(adminContact);


		Order order =  new Order();
		order.setType(OrderType.Contact_Update);
		order.setDomain(domain);


		try {
			//inputs holders

			OrderHolder orderHolder = new OrderHolder(order);

			Response response = env.getClient().createOrder(env.getSessionId(), orderHolder);


			System.out.println("CreateOrder ResultCode\t: " + response.getResultCode().toString());
			System.out.println("CreateOrder Message\t: " + response.getMessage());
			System.out.println("Created OrderId\t\t: " + orderHolder.value.getOrderId());
			if(response.getResultCode() == 400) {
				for( String value : response.getValues()) {
					System.out.println("Error:	" + value);
				}
			}
			env.repeatSync(orderHolder.value.getOrderId(), 10);
			return response;
           
		} catch (Exception e) {
			System.out.print(e);
		}
		return new Response();

	}
}