package ascio.v2.examples;
import com.ascio.www._2007._01.*;
import com.ascio.www._2007._01.holders.*;
import ascio.lib.*;

public class Nameserver_UpdateExample {
	public static Response main() {
		AscioConfig config = new AscioConfig();
		V2 env = config.getTesting().getV2();


		NameServer nameServer1 =  new NameServer();
		nameServer1.setHostName("ns1.ascio.com");


		NameServer nameServer2 =  new NameServer();
		nameServer2.setHostName("ns2.ascio.com");


		NameServers nameServers =  new NameServers();
		nameServers.setNameServer1(nameServer1);
		nameServers.setNameServer2(nameServer2);


		Domain domain =  new Domain();
		domain.setDomainName(env.getProperties().getProperty("DomainName"));
		domain.setNameServers(nameServers);


		Order order =  new Order();
		order.setType(OrderType.Nameserver_Update);
		order.setDomain(domain);


		try {
			//inputs holders

			OrderHolder orderHolder = new OrderHolder(order);

			Response response = env.getClient().createOrder(env.getSessionId(), orderHolder);


			System.out.println("CreateOrder ResultCode\t: " + response.getResultCode().toString());
			System.out.println("CreateOrder Message\t: " + response.getMessage());
			System.out.println("Created OrderId\t\t: " + orderHolder.value.getOrderId());
			if(response.getResultCode() == 400) {
				for( String value : response.getValues()) {
					System.out.println("Error:	" + value);
				}
			}
			env.repeatSync(orderHolder.value.getOrderId(), 10);
			return response;
           
		} catch (Exception e) {
			System.out.print(e);
		}
		return new Response();

	}
}