package ascio.v2.examples;
import java.util.Calendar;
import com.ascio.www._2007._01.*;
import com.ascio.www._2007._01.holders.*;
import ascio.lib.*;
import javax.xml.rpc.holders.*;

public class SearchOrderExample {
	public static Response main() {
		AscioConfig config = new AscioConfig();
		V2 env = config.getTesting().getV2();


		PagingInfo pageInfo =  new PagingInfo();
		pageInfo.setPageIndex(1);
		pageInfo.setPageSize(1);


		SearchOrderRequest orderRequest =  new SearchOrderRequest();
		orderRequest.setOrderTypes(new OrderType[]{OrderType.Register_Domain});
		orderRequest.setOrderStatusTypes(new OrderStatusType[]{OrderStatusType.Validated});
		orderRequest.setFromDate(Calendar.getInstance());
		orderRequest.setToDate(Calendar.getInstance());
		orderRequest.setDomainName("ascio-test-domain"+System.currentTimeMillis()+".com");
		orderRequest.setTransactionComment("TransactionCommentTest");
		orderRequest.setComments("CommentsTest");
		orderRequest.setIncludeDomainDetails(true);
		orderRequest.setPageInfo(pageInfo);
		orderRequest.setOrderSort(SearchOrderSortType.CreDateAsc);


		try {
			//outputs holders

			ResponseHolder searchOrderResultHolder = new ResponseHolder();
			IntegerWrapperHolder totalOrdersHolder = new IntegerWrapperHolder();
			ArrayOfOrderHolder ordersHolder = new ArrayOfOrderHolder();

			env.getClient().searchOrder(env.getSessionId(), orderRequest, searchOrderResultHolder, totalOrdersHolder, ordersHolder);

			Response response = searchOrderResultHolder.value;

			System.out.println("SearchOrder ResultCode\t: " + response.getResultCode().toString());
			System.out.println("SearchOrder Message\t: " + response.getMessage());
			System.out.println("totalOrders\t\t: " + totalOrdersHolder.value);        
        
			if(response.getResultCode() == 400) {
				for( String value : response.getValues()) {
					System.out.println("Error:	" + value);
				}
			}
			return response;
           
		} catch (Exception e) {
			System.out.print(e);
		}
		return new Response();

	}
}