package ascio.v3.examples;
import java.util.Calendar;
import com.ascio.www._2013._02.*;
import ascio.lib.*;

public class GetOrdersExample {
	public static GetOrdersResponse main() {
		AscioConfig config = new AscioConfig();
		V3 env = config.getTesting().getV3();

		PagingInfo pageInfo =  new PagingInfo();
		pageInfo.setPageIndex(1);
		pageInfo.setPageSize(1);


		GetOrdersRequest request =  new GetOrdersRequest();
		request.setTransactionComment("TransactionCommentTest");
		request.setComments("CommentsTest");
		request.setObjectName("ObjectNameTest");
		request.setFromDate(Calendar.getInstance());
		request.setToDate(Calendar.getInstance());
		request.setOrderStatusTypes(new OrderStatusType[]{OrderStatusType.Validated});
		request.setOrderTypes(new OrderType[]{OrderType.Register});
		request.setObjectTypes(new ObjectType[]{ObjectType.SslCertificateType});
		request.setOrderSort(SearchOrderSortType.CreatedAsc);
		request.setPageInfo(pageInfo);


		try {
			GetOrdersResponse response = env.getClient().getOrders(request);			
			System.out.println("response\n");
			System.out.println("GetOrders Code\t:" + response.getResultCode());
			System.out.println("GetOrders Message\t: " + response.getResultMessage());

			if(response.getResultCode() > 200){
				for(String error : response.getErrors()) {
					System.out.print(error);
				}	
			}		
			return response;
           
		} catch (Exception e) {
			System.out.print(e);
		}
		return new GetOrdersResponse();

	}
}