package ascio.v3.examples;
import com.ascio.www._2013._02.*;
import ascio.lib.*;

public class RegisterAutoInstallSslOrderRequestExample {
	public static CreateOrderResponse main() {
		AscioConfig config = new AscioConfig();
		V3 env = config.getTesting().getV3();

		AutoInstallSsl autoInstallSsl =  new AutoInstallSsl();
		autoInstallSsl.setHandle("JD123");
		autoInstallSsl.setCommonName("ascio-test-domain.com");
		autoInstallSsl.setProductCode("positivessl");
		autoInstallSsl.setEmail("administrator@ascio-test-domain.com");
		autoInstallSsl.setSanCount(1);


		AutoInstallSslOrderRequest request =  new AutoInstallSslOrderRequest();
		request.setType(OrderType.Register);
		request.setPeriod(1);
		request.setTransactionComment("TransactionCommentTest");
		request.setComments("CommentsTest");
		request.setDocumentation("DocumentationTest");
		request.setOptions("OptionsTest");
		request.setAutoInstallSsl(autoInstallSsl);


		try {
			CreateOrderResponse response = env.getClient().createOrder(request);			
			System.out.println("response\n");
			System.out.println("CreateOrder Code\t:" + response.getResultCode());
			System.out.println("CreateOrder Message\t: " + response.getResultMessage());

			System.out.println("Created OrderId	: "+response.getOrderInfo().getOrderId());
			if(response.getResultCode() > 200){
				for(String error : response.getErrors()) {
					System.out.print(error);
				}	
			}		
			return response;
           
		} catch (Exception e) {
			System.out.print(e);
		}
		return new CreateOrderResponse();

	}
}