package ascio.v3.examples;
import com.ascio.www._2013._02.*;
import ascio.lib.*;

public class RegisterDomainOrderRequestExample {
	public static CreateOrderResponse main() {
		AscioConfig config = new AscioConfig();
		V3 env = config.getTesting().getV3();


		Registrant owner =  new Registrant();
		owner.setFirstName("John");
		owner.setLastName("Doe");
		owner.setAddress1("Address1Test");
		owner.setCity("CityTest");
		owner.setPostalCode("888349");
		owner.setCountryCode("DK");
		owner.setPhone("+45.123456789");
		owner.setEmail("administrator@ascio-test-domain.com");


		Contact admin =  new Contact();
		admin.setFirstName("John");
		admin.setLastName("Doe");
		admin.setAddress1("Address1Test");
		admin.setCity("CityTest");
		admin.setPostalCode("888349");
		admin.setCountryCode("DK");
		admin.setPhone("+45.123456789");
		admin.setEmail("administrator@ascio-test-domain.com");


		Contact tech =  new Contact();
		tech.setFirstName("John");
		tech.setLastName("Doe");
		tech.setAddress1("Address1Test");
		tech.setCity("CityTest");
		tech.setPostalCode("888349");
		tech.setCountryCode("DK");
		tech.setPhone("+45.123456789");
		tech.setEmail("administrator@ascio-test-domain.com");


		Contact billing =  new Contact();
		billing.setFirstName("John");
		billing.setLastName("Doe");
		billing.setAddress1("Address1Test");
		billing.setCity("CityTest");
		billing.setPostalCode("888349");
		billing.setCountryCode("DK");
		billing.setPhone("+45.123456789");
		billing.setEmail("administrator@ascio-test-domain.com");


		Contact reseller =  new Contact();
		reseller.setFirstName("John");
		reseller.setLastName("Doe");
		reseller.setAddress1("Address1Test");
		reseller.setCity("CityTest");
		reseller.setPostalCode("888349");
		reseller.setCountryCode("DK");
		reseller.setPhone("+45.123456789");
		reseller.setEmail("administrator@ascio-test-domain.com");


		NameServer nameServer1 =  new NameServer();
		nameServer1.setHostName("ns1.ascio.net");


		NameServer nameServer2 =  new NameServer();
		nameServer2.setHostName("ns2.ascio.net");


		NameServer nameServer3 =  new NameServer();
		nameServer3.setHostName("ns3.ascio.net");


		NameServer nameServer4 =  new NameServer();
		nameServer4.setHostName("ns4.ascio.net");


		NameServers nameServers =  new NameServers();
		nameServers.setNameServer1(nameServer1);
		nameServers.setNameServer2(nameServer2);
		nameServers.setNameServer3(nameServer3);
		nameServers.setNameServer4(nameServer4);


		DomainTradeMark trademark =  new DomainTradeMark();
		trademark.setName("ascio-is-great.com");
		trademark.setCountry("DK");
		trademark.setDate(Calendar.getInstance());
		trademark.setNumber("NumberTest");
		trademark.setType("owner");
		trademark.setContact("ContactTest");
		trademark.setContactLanguage("ContactLanguageTest");
		trademark.setDocumentationLanguage("DocumentationLanguageTest");
		trademark.setSecondContact("SecondContactTest");
		trademark.setThirdContact("ThirdContactTest");
		trademark.setRegDate(Calendar.getInstance());


		DnsSecKey dnsSecKey1 =  new DnsSecKey();
		dnsSecKey1.setHandle("JD123");


		DnsSecKey dnsSecKey2 =  new DnsSecKey();
		dnsSecKey2.setHandle("JD123");


		DnsSecKeys dnsSecKeys =  new DnsSecKeys();
		dnsSecKeys.setDnsSecKey1(dnsSecKey1);
		dnsSecKeys.setDnsSecKey2(dnsSecKey2);


		KeyValue keyValue =  new KeyValue();
		keyValue.setKey("Title");
		keyValue.setValue("Mr.");


		ExtensionsKeyValue privacyProxyExtensions[] =  new ExtensionsKeyValue[]{new ExtensionsKeyValue()};


		PrivacyProxy privacyProxy =  new PrivacyProxy();
		privacyProxy.setType(PrivacyProxyType.None);
		privacyProxy.setPrivacyAdmin(false);
		privacyProxy.setPrivacyTech(false);
		privacyProxy.setPrivacyBilling(false);
		privacyProxy.setExtensions(privacyProxyExtensions);


		Domain domain =  new Domain();
		domain.setName("ascio-is-great.com");
		domain.setHandle("JD123");
		domain.setRenewPeriod(1);
		domain.setAuthInfo("X4FF!zu");
		domain.setEncodingType("EncodingTypeTest");
		domain.setDomainPurpose("DomainPurposeTest");
		domain.setComment("CommentTest");
		domain.setTransferLock("Unlock");
		domain.setDeleteLock("Unlock");
		domain.setUpdateLock("Unlock");
		domain.setQueueType("QueueTypeTest");
		domain.setOwner(owner);
		domain.setAdmin(admin);
		domain.setTech(tech);
		domain.setBilling(billing);
		domain.setReseller(reseller);
		domain.setNameServers(nameServers);
		domain.setTrademark(trademark);
		domain.setDnsSecKeys(dnsSecKeys);
		domain.setPrivacyProxy(privacyProxy);
		domain.setDomainType("DomainTypeTest");
		domain.setDiscloseSocialData("true");
		domain.setLocalPresence(false);


		DomainOrderRequest request =  new DomainOrderRequest();
		request.setType(OrderType.Register);
		request.setPeriod(1);
		request.setTransactionComment("TransactionCommentTest");
		request.setComments("CommentsTest");
		request.setDocumentation("DocumentationTest");
		request.setOptions("OptionsTest");
		request.setDomain(domain);
		request.setAgreedPrice(1);


		try {
			CreateOrderResponse response = env.getClient().createOrder(request);			
			System.out.println("response\n");
			System.out.println("CreateOrder Code\t:" + response.getResultCode());
			System.out.println("CreateOrder Message\t: " + response.getResultMessage());

			System.out.println("Created OrderId	: "+response.getOrderInfo().getOrderId());
			if(response.getResultCode() > 200){
				for(String error : response.getErrors()) {
					System.out.print(error);
				}	
			}		
			return response;
		} catch (Exception e) {
			System.out.print(e);
		}
		return new CreateOrderResponse();

	}
}