use SOAP::Lite;
use Date::Format;
$proxy = "https://aws.demo.ascio.com/v3/AscioService.svc";
$namespace = "http://www.ascio.com/2007/01";
$soap = SOAP::Lite
    ->on_action( sub { "CreateOrder" } )
    ->proxy($proxy)
    ->ns("http://www.ascio.com/2013/02", "v3")
    ->ns("http://www.ascio.com/2013/02/AscioService", "service");
    
# Please enter your ascio-credentials here

my $header = SOAP::Header->new(
            name =>"v3:SecurityHeaderDetails",
            value => {"v3:Account" => "username", "v3:Password" =>"password"} 
        );
$soap->autotype(0);
$method = SOAP::Data->name("service:CreateOrder")->attr({xmlns => $namespace});


#AutoInstallSsl
$autoInstallSsl =  \SOAP::Data->value(
	SOAP::Data->name('v3:Handle','JD123'),
	SOAP::Data->name('v3:CommonName','ascio-test-domain.com'),
	SOAP::Data->name('v3:ProductCode','positivessl'),
	SOAP::Data->name('v3:Email',"administrator@ascio-test-domain.com"),
	SOAP::Data->name('v3:SanCount',1),
	SOAP::Data->name('v3:ObjectComment','Example Object Comment')
);


#AutoInstallSslOrderRequest
$request =  \SOAP::Data->value(
	SOAP::Data->name('v3:Type','Register'),
	SOAP::Data->name('v3:Period',1),
	SOAP::Data->name('v3:TransactionComment','TransactionCommentTest'),
	SOAP::Data->name('v3:Comments','CommentsTest'),
	SOAP::Data->name('v3:Documentation','DocumentationTest'),
	SOAP::Data->name('v3:Options','OptionsTest'),
	SOAP::Data->name('v3:AutoInstallSsl',$autoInstallSsl)
);

@query = (
	SOAP::Data->name("service:request" => $request)->attr({"xsi:type" => "v3:AutoInstallSslOrderRequest"})
);
$result = $soap->call($method => @query, $header);
unless ($result->fault) {
	$response = $result->valueof("//CreateOrderResponse/CreateOrderResult");
	print "ResultCode : $response->{'ResultCode'}\r\n";
	print "Message : $response->{'ResultMessage'}\r\n";
	print "Values: ", join(", ", $result->valueof("//CreateOrderResponse/CreateOrderResult/Errors/[>0]")), "\n";
	if ($response->{"ResultCode"} == 200) {
		$order = $result->valueof("//CreateOrderResponse/order");
		print "OrderId : $order->{'OrderId'}\r\n";
	}
}
else {
	print join ", ",
	$result->faultcode,
	$result->faultstring,
	$result->faultdetail;
}