use SOAP::Lite;
use Date::Format;
$proxy = "https://aws.demo.ascio.com/v3/AscioService.svc";
$namespace = "http://www.ascio.com/2007/01";
$soap = SOAP::Lite
    ->on_action( sub { "CreateOrder" } )
    ->proxy($proxy)
    ->ns("http://www.ascio.com/2013/02", "v3")
    ->ns("http://www.ascio.com/2013/02/AscioService", "service");
    
# Please enter your ascio-credentials here

my $header = SOAP::Header->new(
            name =>"v3:SecurityHeaderDetails",
            value => {"v3:Account" => "username", "v3:Password" =>"password"} 
        );
$soap->autotype(0);
$method = SOAP::Data->name("service:CreateOrder")->attr({xmlns => $namespace});


#Registrant
$owner =  \SOAP::Data->value(
	SOAP::Data->name('v3:FirstName','John'),
	SOAP::Data->name('v3:LastName','Doe'),
	SOAP::Data->name('v3:Address1','Address1Test'),
	SOAP::Data->name('v3:City','CityTest'),
	SOAP::Data->name('v3:PostalCode','888349'),
	SOAP::Data->name('v3:CountryCode','DK'),
	SOAP::Data->name('v3:Phone','+45.123456789'),
	SOAP::Data->name('v3:Email',"administrator@ascio-test-domain.com")
);


#Contact
$admin =  \SOAP::Data->value(
	SOAP::Data->name('v3:FirstName','John'),
	SOAP::Data->name('v3:LastName','Doe'),
	SOAP::Data->name('v3:Address1','Address1Test'),
	SOAP::Data->name('v3:City','CityTest'),
	SOAP::Data->name('v3:PostalCode','888349'),
	SOAP::Data->name('v3:CountryCode','DK'),
	SOAP::Data->name('v3:Phone','+45.123456789'),
	SOAP::Data->name('v3:Email',"administrator@ascio-test-domain.com")
);


#Contact
$tech =  \SOAP::Data->value(
	SOAP::Data->name('v3:FirstName','John'),
	SOAP::Data->name('v3:LastName','Doe'),
	SOAP::Data->name('v3:Address1','Address1Test'),
	SOAP::Data->name('v3:City','CityTest'),
	SOAP::Data->name('v3:PostalCode','888349'),
	SOAP::Data->name('v3:CountryCode','DK'),
	SOAP::Data->name('v3:Phone','+45.123456789'),
	SOAP::Data->name('v3:Email',"administrator@ascio-test-domain.com")
);


#Contact
$billing =  \SOAP::Data->value(
	SOAP::Data->name('v3:FirstName','John'),
	SOAP::Data->name('v3:LastName','Doe'),
	SOAP::Data->name('v3:Address1','Address1Test'),
	SOAP::Data->name('v3:City','CityTest'),
	SOAP::Data->name('v3:PostalCode','888349'),
	SOAP::Data->name('v3:CountryCode','DK'),
	SOAP::Data->name('v3:Phone','+45.123456789'),
	SOAP::Data->name('v3:Email',"administrator@ascio-test-domain.com")
);


#Contact
$reseller =  \SOAP::Data->value(
	SOAP::Data->name('v3:FirstName','John'),
	SOAP::Data->name('v3:LastName','Doe'),
	SOAP::Data->name('v3:Address1','Address1Test'),
	SOAP::Data->name('v3:City','CityTest'),
	SOAP::Data->name('v3:PostalCode','888349'),
	SOAP::Data->name('v3:CountryCode','DK'),
	SOAP::Data->name('v3:Phone','+45.123456789'),
	SOAP::Data->name('v3:Email',"administrator@ascio-test-domain.com")
);


#NameServer
$nameServer1 =  \SOAP::Data->value(
	SOAP::Data->name('v3:HostName','ns1.ascio.net')
);


#NameServer
$nameServer2 =  \SOAP::Data->value(
	SOAP::Data->name('v3:HostName','ns2.ascio.net')
);


#NameServer
$nameServer3 =  \SOAP::Data->value(
	SOAP::Data->name('v3:HostName','ns3.ascio.net')
);


#NameServer
$nameServer4 =  \SOAP::Data->value(
	SOAP::Data->name('v3:HostName','ns4.ascio.net')
);


#NameServers
$nameServers =  \SOAP::Data->value(
	SOAP::Data->name('v3:NameServer1',$nameServer1),
	SOAP::Data->name('v3:NameServer2',$nameServer2),
	SOAP::Data->name('v3:NameServer3',$nameServer3),
	SOAP::Data->name('v3:NameServer4',$nameServer4)
);


#DomainTradeMark
$trademark =  \SOAP::Data->value(
	SOAP::Data->name('v3:Name','ascio-is-great.com'),
	SOAP::Data->name('v3:Country','DK'),
	SOAP::Data->name('v3:Date',time2str('%Y-%m-%dT%H:%M:%SZ', time, 'EST')),
	SOAP::Data->name('v3:Number','NumberTest'),
	SOAP::Data->name('v3:Type','owner'),
	SOAP::Data->name('v3:Contact','ContactTest'),
	SOAP::Data->name('v3:ContactLanguage','ContactLanguageTest'),
	SOAP::Data->name('v3:DocumentationLanguage','DocumentationLanguageTest'),
	SOAP::Data->name('v3:SecondContact','SecondContactTest'),
	SOAP::Data->name('v3:ThirdContact','ThirdContactTest'),
	SOAP::Data->name('v3:RegDate',time2str('%Y-%m-%dT%H:%M:%SZ', time, 'EST'))
);


#DnsSecKey
$dnsSecKey1 =  \SOAP::Data->value(
	SOAP::Data->name('v3:Handle','JD123')
);


#DnsSecKey
$dnsSecKey2 =  \SOAP::Data->value(
	SOAP::Data->name('v3:Handle','JD123')
);


#DnsSecKeys
$dnsSecKeys =  \SOAP::Data->value(
	SOAP::Data->name('v3:DnsSecKey1',$dnsSecKey1),
	SOAP::Data->name('v3:DnsSecKey2',$dnsSecKey2)
);


#KeyValue
$keyValue =  \SOAP::Data->value(
	SOAP::Data->name('v3:Key','Title'),
	SOAP::Data->name('v3:Value','Mr.')
);


#Extensions
$privacyProxyExtensions =  \SOAP::Data->value(
);


#PrivacyProxy
$privacyProxy =  \SOAP::Data->value(
	SOAP::Data->name('v3:Type','None'),
	SOAP::Data->name('v3:PrivacyAdmin','false'),
	SOAP::Data->name('v3:PrivacyTech','false'),
	SOAP::Data->name('v3:PrivacyBilling','false'),
	SOAP::Data->name('v3:Extensions',$privacyProxyExtensions)
);


#Domain
$domain =  \SOAP::Data->value(
	SOAP::Data->name('v3:Name','ascio-is-great.com'),
	SOAP::Data->name('v3:Handle','JD123'),
	SOAP::Data->name('v3:RenewPeriod',1),
	SOAP::Data->name('v3:AuthInfo','X4FF!zu'),
	SOAP::Data->name('v3:EncodingType','EncodingTypeTest'),
	SOAP::Data->name('v3:DomainPurpose','DomainPurposeTest'),
	SOAP::Data->name('v3:Comment','CommentTest'),
	SOAP::Data->name('v3:TransferLock','Unlock'),
	SOAP::Data->name('v3:DeleteLock','Unlock'),
	SOAP::Data->name('v3:UpdateLock','Unlock'),
	SOAP::Data->name('v3:QueueType','QueueTypeTest'),
	SOAP::Data->name('v3:Owner',$owner),
	SOAP::Data->name('v3:Admin',$admin),
	SOAP::Data->name('v3:Tech',$tech),
	SOAP::Data->name('v3:Billing',$billing),
	SOAP::Data->name('v3:Reseller',$reseller),
	SOAP::Data->name('v3:NameServers',$nameServers),
	SOAP::Data->name('v3:Trademark',$trademark),
	SOAP::Data->name('v3:DnsSecKeys',$dnsSecKeys),
	SOAP::Data->name('v3:PrivacyProxy',$privacyProxy),
	SOAP::Data->name('v3:DomainType','DomainTypeTest'),
	SOAP::Data->name('v3:DiscloseSocialData','true'),
	SOAP::Data->name('v3:LocalPresence','false')
);


#DomainOrderRequest
$request =  \SOAP::Data->value(
	SOAP::Data->name('v3:Type','Register'),
	SOAP::Data->name('v3:Period',1),
	SOAP::Data->name('v3:TransactionComment','TransactionCommentTest'),
	SOAP::Data->name('v3:Comments','CommentsTest'),
	SOAP::Data->name('v3:Documentation','DocumentationTest'),
	SOAP::Data->name('v3:Options','OptionsTest'),
	SOAP::Data->name('v3:Domain',$domain),
	SOAP::Data->name('v3:AgreedPrice',1)
);

@query = (
	SOAP::Data->name("service:request" => $request)->attr({"xsi:type" => "v3:DomainOrderRequest"})
);
$result = $soap->call($method => @query, $header);
unless ($result->fault) {
	$response = $result->valueof("//CreateOrderResponse/CreateOrderResult");
	print "ResultCode : $response->{'ResultCode'}\r\n";
	print "Message : $response->{'ResultMessage'}\r\n";
	print "Values: ", join(", ", $result->valueof("//CreateOrderResponse/CreateOrderResult/Errors/[>0]")), "\n";
	if ($response->{"ResultCode"} == 200) {
		$order = $result->valueof("//CreateOrderResponse/order");
		print "OrderId : $order->{'OrderId'}\r\n";
	}
}
else {
	print join ", ",
	$result->faultcode,
	$result->faultstring,
	$result->faultdetail;
}