<?php
namespace ascio\v3\examples;
require("../service/autoload.php");
require("../../lib/AscioConfig.php");
use ascio\v3 as ascio;
use ascio\lib as lib;
function registerDomainOrderRequestExample() {
	$config = new lib\Config();
	$env = $config->get("testing"); //testing or live
	$credentials = array("Account"=>$env->getAccount(), "Password" => $env->getPassword());
	$header = new \SoapHeader("http://www.ascio.com/2013/02","SecurityHeaderDetails", $credentials, false);
	$ascioClient	 = new ascio\AscioService(array("trace" => true),$env->getWsdl("v3"));
	$ascioClient->__setSoapHeaders($header);


	$owner =  new ascio\Registrant();
	$owner->setFirstName("John");
	$owner->setLastName("Doe");
	$owner->setAddress1("Address1Test");
	$owner->setCity("CityTest");
	$owner->setPostalCode("888349");
	$owner->setCountryCode("DK");
	$owner->setPhone("+45.123456789");
	$owner->setEmail("administrator@ascio-test-domain.com");


	$admin =  new ascio\Contact();
	$admin->setFirstName("John");
	$admin->setLastName("Doe");
	$admin->setAddress1("Address1Test");
	$admin->setCity("CityTest");
	$admin->setPostalCode("888349");
	$admin->setCountryCode("DK");
	$admin->setPhone("+45.123456789");
	$admin->setEmail("administrator@ascio-test-domain.com");


	$tech =  new ascio\Contact();
	$tech->setFirstName("John");
	$tech->setLastName("Doe");
	$tech->setAddress1("Address1Test");
	$tech->setCity("CityTest");
	$tech->setPostalCode("888349");
	$tech->setCountryCode("DK");
	$tech->setPhone("+45.123456789");
	$tech->setEmail("administrator@ascio-test-domain.com");


	$billing =  new ascio\Contact();
	$billing->setFirstName("John");
	$billing->setLastName("Doe");
	$billing->setAddress1("Address1Test");
	$billing->setCity("CityTest");
	$billing->setPostalCode("888349");
	$billing->setCountryCode("DK");
	$billing->setPhone("+45.123456789");
	$billing->setEmail("administrator@ascio-test-domain.com");


	$reseller =  new ascio\Contact();
	$reseller->setFirstName("John");
	$reseller->setLastName("Doe");
	$reseller->setAddress1("Address1Test");
	$reseller->setCity("CityTest");
	$reseller->setPostalCode("888349");
	$reseller->setCountryCode("DK");
	$reseller->setPhone("+45.123456789");
	$reseller->setEmail("administrator@ascio-test-domain.com");


	$nameServer1 =  new ascio\NameServer();
	$nameServer1->setHostName("ns1.ascio.net");


	$nameServer2 =  new ascio\NameServer();
	$nameServer2->setHostName("ns2.ascio.net");


	$nameServer3 =  new ascio\NameServer();
	$nameServer3->setHostName("ns3.ascio.net");


	$nameServer4 =  new ascio\NameServer();
	$nameServer4->setHostName("ns4.ascio.net");


	$nameServers =  new ascio\NameServers();
	$nameServers->setNameServer1($nameServer1);
	$nameServers->setNameServer2($nameServer2);
	$nameServers->setNameServer3($nameServer3);
	$nameServers->setNameServer4($nameServer4);


	$trademark =  new ascio\DomainTradeMark();
	$trademark->setName("ascio-is-great.com");
	$trademark->setCountry("DK");
	$trademark->setDate("DateTest");
	$trademark->setNumber("NumberTest");
	$trademark->setType("owner");
	$trademark->setContact("ContactTest");
	$trademark->setContactLanguage("ContactLanguageTest");
	$trademark->setDocumentationLanguage("DocumentationLanguageTest");
	$trademark->setSecondContact("SecondContactTest");
	$trademark->setThirdContact("ThirdContactTest");
	$trademark->setRegDate("RegDateTest");


	$dnsSecKey1 =  new ascio\DnsSecKey();
	$dnsSecKey1->setHandle("JD123");


	$dnsSecKey2 =  new ascio\DnsSecKey();
	$dnsSecKey2->setHandle("JD123");


	$dnsSecKeys =  new ascio\DnsSecKeys();
	$dnsSecKeys->setDnsSecKey1($dnsSecKey1);
	$dnsSecKeys->setDnsSecKey2($dnsSecKey2);


	$keyValue =  new ascio\KeyValue();
	$keyValue->setKey("Title");
	$keyValue->setValue("Mr.");


	$privacyProxyExtensions =  new ascio\Extensions();
	$privacyProxyExtensions->setKeyValue([$keyValue]);


	$privacyProxy =  new ascio\PrivacyProxy();
	$privacyProxy->setType(ascio\PrivacyProxyType::None);
	$privacyProxy->setPrivacyAdmin(false);
	$privacyProxy->setPrivacyTech(false);
	$privacyProxy->setPrivacyBilling(false);
	$privacyProxy->setExtensions($privacyProxyExtensions);


	$domain =  new ascio\Domain();
	$domain->setName("ascio-is-great.com");
	$domain->setHandle("JD123");
	$domain->setRenewPeriod(1);
	$domain->setAuthInfo("X4FF!zu");
	$domain->setEncodingType("EncodingTypeTest");
	$domain->setDomainPurpose("DomainPurposeTest");
	$domain->setComment("CommentTest");
	$domain->setTransferLock("Unlock");
	$domain->setDeleteLock("Unlock");
	$domain->setUpdateLock("Unlock");
	$domain->setQueueType("QueueTypeTest");
	$domain->setOwner($owner);
	$domain->setAdmin($admin);
	$domain->setTech($tech);
	$domain->setBilling($billing);
	$domain->setReseller($reseller);
	$domain->setNameServers($nameServers);
	$domain->setTrademark($trademark);
	$domain->setDnsSecKeys($dnsSecKeys);
	$domain->setPrivacyProxy($privacyProxy);
	$domain->setDomainType("DomainTypeTest");
	$domain->setDiscloseSocialData("true");
	$domain->setLocalPresence(false);


	$request =  new ascio\DomainOrderRequest();
	$request->setType(ascio\OrderType::Register);
	$request->setPeriod(1);
	$request->setTransactionComment("TransactionCommentTest");
	$request->setComments("CommentsTest");
	$request->setDocumentation("DocumentationTest");
	$request->setOptions("OptionsTest");
	$request->setDomain($domain);
	$request->setAgreedPrice(1);

	echo "start validate\n";
	$validateOrder = new  ascio\ValidateOrder($request);
	try {
		$response = $ascioClient->ValidateOrder($validateOrder);
	} catch (\Exception $e) {
		echo ("[".$e->faultcode . "] ". $e->faultstring);
		return;
	}
	echo "end validate\n";
	
	if ($response->getValidateOrderResult()->getResultCode() == 200) {
		echo "Validation: OK\r\n";
		try {
			$createOrderResponse = $ascioClient->CreateOrder(new ascio\CreateOrder($request));
		} catch (\Exception $e) {
			echo ("[".$e->faultcode . "] ". $e->faultstring);
			return;
		}
		echo "Create Order: ".$createOrderResponse->CreateOrderResult->getResultCode() . " " . $createOrderResponse->CreateOrderResult->getResultMessage() . "\r\n";
		if ($createOrderResponse->CreateOrderResult->getResultCode() == 200) {
			echo "OrderId : " . $createOrderResponse->CreateOrderResult->getOrderInfo()->getOrderId() . "\r\n";
			echo "Order Status : " . $createOrderResponse->CreateOrderResult->getOrderInfo()->getStatus() . "\r\n";
		} else {
			echo ($response->CreateOrderResult->getResultMessage()."\n");
			foreach($createOrderResponse->CreateOrderResult->getErrors() as $error) {
				echo $error."\n";
				return $response;
			}
		}
		return $createOrderResponse;
	} else {
		echo ($response->getValidateOrderResult()->getResultMessage()."\n");
		if ($response->getValidateOrderResult()->getErrors()) {
			foreach($response->getValidateOrderResult()->getErrors()->getString() as $error) {
				 echo $error."\n";
			}
		}
		return $response;
	}
}
registerDomainOrderRequestExample();